//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "stdinclude.h"
#include "klondike.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
    board=new Klondike();
    board->InitGame();
    board->Deal();

}
//---------------------------------------------------------------------------


void __fastcall TMainForm::Draw(TObject *Sender)
{
    board->Draw(Canvas->Handle);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DoExiting(TObject *Sender, TCloseAction &Action)
{
    delete board;

    Action=caFree;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DoMDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    if (board->OnMouseDown(Button,X,Y))
    {
        //Repaint();
        /*
        Canvas->Brush->Color=clGreen;
        Canvas->FillRect(ClientRect);
        board->Draw(Canvas->Handle);
        */
        Update();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DoMUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    if (board->OnMouseUp(Button,X,Y))
    {
        //Repaint();
        /*
        Canvas->Brush->Color=clGreen;
        Canvas->FillRect(ClientRect);
        board->Draw(Canvas->Handle);
        */
        Update();
        if (board->CheckFinish())
            Application->MessageBoxA("Victory","Game Won",MB_OK);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DoMMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    if (Shift.Contains(ssLeft))
    {
        if (board->OnMouseMove(X,Y))
        {
            //Repaint();
            /*
            Canvas->Brush->Color=clGreen;
            Canvas->FillRect(ClientRect);
            board->Draw(Canvas->Handle);
            */
            Update();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Deal1Click(TObject *Sender)
{
    board->Clear();
    board->InitGame();
    board->Deal();
    Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------

